﻿using System;

namespace SilverHtmlContent
{
	public class SilverHtmlAttributeItem
	{
		protected string		m_attribute_name	= "",
								m_value				= "";

		public SilverHtmlAttributeItem()
		{
		}

		public SilverHtmlAttributeItem(string attribute_name, string attribute_value)
		{
			m_attribute_name	= attribute_name;
			m_value				= attribute_value;
		}


		public SilverHtmlAttributeItem(Html_style_common_attributes attrib_enum, string attribute_value)
		{
			m_attribute_name	= HtmlStyleName(attrib_enum);
			m_value				= attribute_value;
		}

		public SilverHtmlAttributeItem(Html_common_properties attrib_enum, string attribute_value)
		{
			m_attribute_name	= HtmlPropertyName(attrib_enum);
			m_value				= attribute_value;
		}


		public string AttributeName
		{
			get { return m_attribute_name; }
			set { m_attribute_name = value; }
		}

		public string AttributeValue
		{
			get { return m_value; }
			set { m_value = value; }
		}

		public string HtmlStyleString
		{
			get
			{
				if( string.IsNullOrEmpty( m_attribute_name) || string.IsNullOrEmpty( m_value))
					return "";

				return m_attribute_name + ":" + m_value + ";";
			}
		}
		
		public string HtmlPropertyString
		{
			get
			{
				if( string.IsNullOrEmpty( m_attribute_name) || string.IsNullOrEmpty( m_value))
					return "";

				return m_attribute_name + "=\"" + m_value + "\"";
			}
		}


#region *************** helpers ***********************


		private static string Normalize_attribute_enum_name(string enum_name)
		{
			if( string.IsNullOrEmpty( enum_name))
				return "";

			/// remove first underscore (ex: like for _class attribute name)
			if (enum_name.StartsWith("_"))
				enum_name = enum_name.Substring(1);

			/// replace underscores by hyphens
			return enum_name.Replace('_', '-');
		}

		public static string HtmlStyleName(Html_style_common_attributes attrib)
		{
			string	str_ret		= Enum.GetName( typeof( Html_style_common_attributes), attrib);

			return Normalize_attribute_enum_name( str_ret);
		}

		public static string HtmlPropertyName(Html_common_properties attrib)
		{
			string str_ret = Enum.GetName(typeof(Html_common_properties), attrib);

			return Normalize_attribute_enum_name(str_ret);
		}

#endregion

	}
}
